# -*- coding: utf-8 -*-
"""
Created on Mon Nov 11 12:49:59 2024

@author: Giovanni
"""
import numpy as np
import matplotlib.pyplot as plt
from SPRT_PCA import SPRT  # Import the SPRT_PCA function

# Define parameters
alpha = 0.01
beta = 0.01
sigma = 0.2

# Loop over mu1 values
for mu1 in np.arange(0.5, 2.5, 0.5):  # Equivalent to MATLAB 0.5:0.5:2
    # Perform SPRT test on the specified datasets
    # Uncomment the following line to test with 'test_4A_meas_S5.dat' and 'test_4A_rec_S5.dat'
    # SPRT_PCA('test_4A_meas_S5.dat', 'test_4A_rec_S5.dat', alpha, beta, mu1, sigma)
    
    # Test with 'test_4B_meas_S5.dat' and 'test_4B_rec_S5.dat'; attention: first you need to save them! 
    SPRT_Index = SPRT('test_4B_meas_S5.dat', 'test_4B_rec_S5.dat', alpha, beta, mu1, sigma)
    # SPRT_Index = SPRT('test_4A_meas_S5.dat', 'test_4A_rec_S5.dat', alpha, beta, mu1, sigma)
    
    # Set title to display current mu1 value
    plt.title(f'mu1 = {mu1}')
    plt.show()  # Show the plot for the current value of mu1
