# -*- coding: utf-8 -*-
"""
Created on Mon Nov 11 11:39:14 2024

@author: Giovanni
"""

from PCA_reconstruction import PCA_reconstruction
import numpy as np
import matplotlib.pyplot as plt

# Load true signal (validation data)
true_signal = np.loadtxt('validation.dat')
N, n = true_signal.shape

# Define the variance levels to test
variance_levels = [0.9, 0.95, 0.98, 0.99, 0.995, 1.0]

# Initialize lists to store results
n_PC = []
rmse = []

# Run PCA reconstruction for each variance level
for v in variance_levels:
    test_reconstruction, n_pc, rmse_val = PCA_reconstruction('train.dat', 'validation.dat', v)
    n_PC.append(n_pc)
    rmse.append(rmse_val)
    plt.close('all')

# Plot number of principal components vs. variance level
plt.figure(1)
plt.plot(variance_levels, n_PC, '-o')
plt.xlabel('Percentage of Variance')
plt.ylabel('Number of Principal Components')
plt.legend(['Number of Principal Components'])
plt.grid(True)

# Plot RMSE vs. variance level
plt.figure(2)
plt.plot(variance_levels, rmse, '-o')
plt.xlabel('Percentage of Variance')
plt.ylabel('RMSE')
plt.legend(['RMSE'])
plt.grid(True)

# Plot RMSE vs. number of principal components
plt.figure(3)
plt.plot(n_PC, rmse, '-o')
plt.xlabel('Number of Principal Components')
plt.ylabel('RMSE')
plt.legend(['RMSE'])
plt.grid(True)

plt.show()
